#!/bin/ksh

function slink
{
	ln -fs ${PWD}/$1 $2
	if [ $? -eq 0 ]; then
		return 0;
	fi
	echo "Error: Cannot link " $1 " to " $2 "\n"
	exit 1
}

function makedir
{
	mkdir -pm0775 $1
	if [ $? -eq 0 ]; then
		return 0;
	fi
	echo "Cannot create dir " $1
	exit 1
}

if [ `id -u` -ne 0 ];  then
        echo "You must be root to install "
fi

if [ `uname -v` -lt 421 ]; then

cat <<-\eof
Warning: Mkshlib requires version QNX version 4.21.
If you experience difficulties with it's operation; you should
upgrade your operating system.

eof
fi

set -x
makedir  /usr/local/bin
makedir  /usr/lib/shlib
slink mkshlib /usr/local/bin/mkshlib
slink shinfo /usr/local/bin/shinfo
slink undef /usr/local/bin/undef
slink mkshlib.skel /usr/lib/shlib/mkshlib.skel
slink shobj.h /usr/include/sys/shobj.h

if [ $? -ne 0 ]; then
cat <<-\eof
Mkshlib could not be successfully installed.
Please review the permissions and directories in your system.
exit 1
fi

cat <<-\eof
Mkshlib has been sucessfully installed.
If you have a PostScript printer; you should print the file
mkshlib.PS to this printer now.
If you do not, there is a text version mkshlib.TXT which you
can view.
eof
return 0;

fi
