/*-
 * shobj.h: structures and manifests to bind shared libraries and applications
 *         at run time.
 *
 * Copyright Quantum Software Systems Ltd (C) 1993. All rights reserved.
 */
 
#ifndef shobj_h
#define shobj_h
#ifndef _LIMITS_H_INCLUDED
#include <limits.h>
#endif

struct segdesc {
	void	*seg_addr;	/* address to map segment to */
	int	seg_len;	/* length to map */
	int	seg_offs;	/* offset of segment in shared memory region */
	int	seg_prot;	/* protection */
	int	seg_map;	/* access bits */
};
struct lnkdesc {
	void	*lnk_addr;
	int	lnk_len;
};

#define	SHO_MAGIC	07766554433
#define SHO_MAXSEG	16
#define SHO_MAXLINK	16
#define SHO_NAMELEN	64

/*-
 * In the slib image
 */
struct	s_bind {
	long	s_magic;	/* magic values. */
	int	s_version;
	char	s_regnam[SHO_NAMELEN];
	int	s_nseg;
	int	s_nlnk;
	struct segdesc s_segs[SHO_MAXSEG];
	struct lnkdesc s_lnks[SHO_MAXLINK];
};

/*-
 * The incore image
 */
struct s_dir {
	struct s_bind  sd_info;
	int            sd_ready;
	char           sd_image[PATH_MAX];
};


struct	u_bind {
	char	u_regnam[SHO_NAMELEN];
	int	u_nlnk;
	struct	lnkdesc u_lnks[SHO_MAXLINK];
};
/*- u_bind:
	u_regname = $0.
	u_nlnk    = $40
	u_lnks[0].lnk_addr = $44
	u_lnks[0].lnk_len  = $48
*/


extern int _sho_open(struct u_bind *u);
extern int _sho_creat(struct s_bind *s);

#endif
